Subject: Re: [Tsvwg] Re: tsvwg digest, Vol 1 #486 - 4 msgs

From: "Daisy Chang" <[email-masked]>
Date: Tue, 29 Jan 2002 18:12:56 -0500

Venkat,
Yes, thanks for pointing it out. I mainly wanted to make sure that there
are no inconsistencies
in the RFC regarding to the "no user data field" rule. So, to stick with
the RFC, looks like we
have to
1. check the message size in API to prevent from sending a 0-length message
as a sender;
2. check the message size in data reception as a receiver and send ABORT to
violators
    of this rule.

Thanks,
Daisy

Daisy Chang
IBM Linux Technology Center
[email-masked]
Tel: (512)-838-4194    T/L: 678-4194
FAX: (512)-838-4663

venkat venkatsubra <[email-masked]>@ietf.org on 01/29/2002 04:53:02
PM

Sent by:    [email-masked]

To:    [email-masked]
cc:    Daisy Chang/Austin/IBM@IBMUS
Subject:    [Tsvwg] Re: tsvwg digest, Vol 1 #486 - 4 msgs

Daisy,

> To: Randall Stewart <[email-masked]>
> Cc: [email-masked], [email-masked]
> From: "Daisy Chang" <[email-masked]>
> Date: Thu, 24 Jan 2002 11:34:20 -0600
> Subject: [Tsvwg] Re: question regarding the SCTP API - SCTP_INIT cmsg
>
> Yes, Randy, I think that the same behavior exists in Linux for TCP and
UDP.
> Well, for TCP, appending 0 bytes to the output queue really is harmless,
> nothing is affected, so it is perfectly OK. For UDP, it seems a little
> wierd if it
> does result into a NULL message on the wire. But for a datagram protocol,
> users are taking more control than they want to in their own hands, so I
> guess
> the protocol has no reason to reject it.
>
> As for SCTP, I think that it makes a lot of sense to disallow NULL user
> messages. I was a bit confused by the wording in 3.3.1 Payload Data
> (RFC2960) where it says "A DATA chunk with no user data field will have
> Length set to 16." But Jon Grimm graciously cleared it up by pointing me
to
> the similar place in your book where it says "It should have a value
equal
> to or greater than 17, because a DATA chunk is required to have at least
> one byte of user data." I gathered that this is what you refered to when
> you
> said that the RFC disallows 0-length send, right?

The last few lines of section 6.2 from rfc2960:

   If an endpoint receives a DATA chunk with no user data (i.e., the
   Length field is set to 16) it MUST send an ABORT with error cause set
   to "No User Data".

   An endpoint SHOULD NOT send a DATA chunk with no user data part.

This must be what Randall must have referred to.

> Thanks for your quick responses. I would suggest that we shall follow
> your interpretation for the sendmsg and connect implementation.
>
> Thanks,
> Daisy
>
> Daisy Chang
> IBM Linux Technology Center
> [email-masked]
> Tel: (512)-838-4194    T/L: 678-4194
> FAX: (512)-838-4663

Venkat

_______________________________________________
tsvwg mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/tsvwg

_______________________________________________
tsvwg mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/tsvwg

---

From: Randall Stewart <[email-masked]>
Date: Tue, 29 Jan 2002 17:33:18 -0600

Yep..

You must check both.. for now my implementation
gives you an EINVAL if you try to send a 0
lenght message and have no msgcontrol structure
that either causes an ABORT or a SHUTDOWN...

Maybe this discussion should move off of tsvwg and over to
[email-masked]... I don't know if 
this is of general interest any more :>

And by the way I am only 700 msg's or so behind in that
list so make sure and copy me directly if you want
me to chime in :=0

R

-- 
Randall R. Stewart
[email-masked] 815-342-5222 (cell phone)